SystemOrganization addCategory: #ReversiGame!

Matrix subclass: #ReversiModel
	instanceVariableNames: 'controller filledCellCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ReversiGame'!

!ReversiModel methodsFor: 'as yet unclassified' stamp: 'Me 4/15/2012 12:19'!
addCell:cellMorph row: atRow col: atCol 
	self at: atRow at: atCol put:cellMorph.! !

!ReversiModel methodsFor: 'as yet unclassified' stamp: 'Me 4/15/2012 20:43'!
checkDirectionWithDiffx: dx y:dy row:rowNum col:colNum p:player
|n tmpCell r c break foundOponents endsCorrectly res|
	res:=0.
	r:=rowNum.
	c:=colNum.
	n:= controller boardSize.
	break:=false.
	foundOponents:=false.
	endsCorrectly:=false.
	[((r+dy<=n) & (c+dx<=n) & (r+dy>0) & (c+dx>0) & (break not))]
	whileTrue:
	[
		r:=r+dy.
		c:=c+dx.
		tmpCell:=self at: r at:c.
		((tmpCell occupied)not)   "if first cell in search direction is not occupied"
		ifTrue: 
		[
			break:=true.
		]
		ifFalse:  					"if cell is occupied"
		[
			(tmpCell occupiedBy:player)    "if ocupied by same player"
			ifTrue:
			[
				endsCorrectly:=true.
				break:=true.
			]
			ifFalse:
			[			
				res:=res+1.	
				foundOponents:=true.
			].
		].
	].
	(foundOponents & endsCorrectly)
	ifFalse:[res:=0.].
	^res.
	! !

!ReversiModel methodsFor: 'as yet unclassified' stamp: 'Me 4/15/2012 11:00'!
controller: newController
	controller:=newController.! !

!ReversiModel methodsFor: 'as yet unclassified' stamp: 'Me 4/15/2012 14:59'!
initialize 
super initialize.
filledCellCount := 0.! !

!ReversiModel methodsFor: 'as yet unclassified' stamp: 'Me 4/16/2012 00:20'!
occupiedRow: atRow col: atCol
	^((self at: atRow at: atCol) occupied)! !

!ReversiModel methodsFor: 'as yet unclassified' stamp: 'Me 4/15/2012 19:39'!
performMoveAtRow: rowNum col:colNum p:player
|res|
	res := (self at: rowNum at: colNum) occupied not.
	res := res & 
	((self validInDirectionWithDiffx: 0 y:1  row:rowNum  col:colNum  p:player ) |
	(self validInDirectionWithDiffx: 0 y:(-1)  row:rowNum  col:colNum  p:player )|
	(self validInDirectionWithDiffx: 1 y:0  row:rowNum  col:colNum  p:player )|
	(self validInDirectionWithDiffx: (-1) y:0  row:rowNum  col:colNum  p:player )|
	
	(self validInDirectionWithDiffx: 1 y:1  row:rowNum  col:colNum  p:player )|
	(self validInDirectionWithDiffx: (-1) y:(-1)  row:rowNum  col:colNum  p:player )|
	(self validInDirectionWithDiffx: 1 y:(-1)  row:rowNum  col:colNum  p:player )|
	(self validInDirectionWithDiffx: (-1) y:1  row:rowNum  col:colNum  p:player )).	
	^res.! !

!ReversiModel methodsFor: 'as yet unclassified' stamp: 'Me 4/15/2012 17:51'!
validInDirectionWithDiffx: dx y:dy row:rowNum col:colNum p:player
|n tmpCell r c break foundOponents endsCorrectly|
	r:=rowNum.
	c:=colNum.
	n:= controller boardSize.
	break:=false.
	foundOponents:=false.
	endsCorrectly:=false.
	[((r+dy<=n) & (c+dx<=n) & (r+dy>0) & (c+dx>0) & (break not))]
	whileTrue:
	[
		r:=r+dy.
		c:=c+dx.
		tmpCell:=self at: r at:c.
		((tmpCell occupied)not)   "if first cell in search direction is not occupied"
		ifTrue: 
		[
			break:=true.
		]
		ifFalse:  					"if cell is occupied"
		[
			(tmpCell occupiedBy:player)    "if ocupied by same player"
			ifTrue:
			[
				endsCorrectly:=true.
				break:=true.
			]
			ifFalse:
			[				
				foundOponents:=true.
			].
		].
	].
	r:=rowNum.
	c:=colNum.
	break:=false.	
	(foundOponents & endsCorrectly)
	ifTrue:
	[
		[((r+dy<=n) & (c+dx<=n) & (r+dy>0) & (c+dx>0) & (break not))]
		whileTrue:
		[
			r:=r+dy.
			c:=c+dx.
			tmpCell:=self at: r at:c.
			(tmpCell occupiedBy:player)  
			ifTrue:
			[
				break:=true.
			]
			ifFalse:  "if ocupied by oponent"
			[			
				tmpCell occupie: player.
			].
		].
	].
	^(foundOponents & endsCorrectly)
	! !

!ReversiModel methodsFor: 'as yet unclassified' stamp: 'Me 4/16/2012 02:22'!
validateMoveAtRow: rowNum c:colNum p:player
|res|
	res :=
	((self checkDirectionWithDiffx: 0 y:1  row:rowNum  col:colNum  p:player )+
	(self checkDirectionWithDiffx: 0 y:(-1)  row:rowNum  col:colNum  p:player )+
	(self checkDirectionWithDiffx: 1 y:0  row:rowNum  col:colNum  p:player )+
	(self checkDirectionWithDiffx: (-1) y:0  row:rowNum  col:colNum  p:player )+
	
	(self checkDirectionWithDiffx: 1 y:1  row:rowNum  col:colNum  p:player )+
	(self checkDirectionWithDiffx: (-1) y:(-1)  row:rowNum  col:colNum  p:player )+
	(self checkDirectionWithDiffx: 1 y:(-1)  row:rowNum  col:colNum  p:player )+
	(self checkDirectionWithDiffx: (-1) y:1  row:rowNum  col:colNum  p:player )).
	((self at: rowNum at: colNum) occupied not)
		ifFalse: [res:=0.].
	^res.! !

Object subclass: #ReversiController
	instanceVariableNames: 'currentPlayer container model boardSize turnShower scoreMorph moves onePlayer walkieTalkie'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ReversiGame'!

!ReversiController methodsFor: 'as yet unclassified' stamp: 'imy 4/16/2012 07:31'!
MakeStepRow:rowNum col:colNum
	(model performMoveAtRow: rowNum col: colNum p:currentPlayer)
	ifTrue:
	[
		(model at: rowNum at: colNum) occupie: currentPlayer .
		self nextPlayer.
		moves:=moves+1.
		self validateBoard:onePlayer.
		
		"Send move to the second player."
		walkieTalkie send: rowNum@colNum.
		self waitForNetworkMove.
	].
! !

!ReversiController methodsFor: 'as yet unclassified' stamp: 'imy 4/16/2012 08:51'!
addGuiControls
 | rowMorph newGameButton exitGameButton |
 rowMorph := Morph new 
             layoutPolicy: RowLayout new; 
             color: Color transparent.
 newGameButton := self createCtrlLabelled: 'New'      onClickExecutes: [self restart ].
 exitGameButton := self createCtrlLabelled: 'Exit'  onClickExecutes: [self exit].
turnShower := FigureMorph new setPlayer: currentPlayer.
 rowMorph addMorph: exitGameButton.
 rowMorph addMorph: newGameButton.
 rowMorph addMorphBack:  turnShower.
rowMorph addMorphBack:  scoreMorph.
 container addMorph: rowMorph.

! !

!ReversiController methodsFor: 'as yet unclassified' stamp: 'Me 4/15/2012 15:57'!
boardSize 
	^boardSize ! !

!ReversiController methodsFor: 'as yet unclassified' stamp: 'imy 4/16/2012 08:41'!
connectToNetworkGame: host port: port
	"Connects to the network game"

	walkieTalkie initializeAsTalkerToHost: host port: port.
	"Open game - temporary thing. TODO: reading game date from the network."
	self open: 6 ai: false.
	"Waiting for the first move."
	self waitForNetworkMove.! !

!ReversiController methodsFor: 'as yet unclassified' stamp: 'Me 4/16/2012 02:48'!
createBoard
| rowMorph aCell rowCol center|
	1 to:boardSize do:
	[ :row |
 		rowMorph := Morph new layoutPolicy: RowLayout new.
		rowMorph color: (Color red alpha:0).
		1 to: boardSize do: 
		[ :col | 
			aCell := BoardCell new.
			aCell setController: (self) row: row col: col.
			model at: row at: col put: aCell.
			rowMorph addMorphBack: aCell.
		].
		container addMorphBack: rowMorph.
	].
	center:=(boardSize/2)  asFloat integerPart.
	(model at:center+1  at: center+1 ) occupie: 1.
	(model at:center  at: center ) occupie: 1.
	(model at:center  at: center+1 ) occupie: 0.
	(model at:center+1  at: center ) occupie: 0.
	moves:=5.! !

!ReversiController methodsFor: 'as yet unclassified' stamp: 'Me 4/15/2012 19:20'!
createCtrlLabelled: aString onClickExecutes: aBlock
 | aCtrlButton |
 aCtrlButton := SimpleButtonMorph new label: aString.
 aCtrlButton color: (Color r:0.2 g:0.2 b:0.2 alpha:0.2).
 aCtrlButton extent: 60@30.
 aCtrlButton on: #click send: #value to: aBlock.
 ^aCtrlButton.! !

!ReversiController methodsFor: 'as yet unclassified' stamp: 'Me 4/15/2012 18:26'!
createScoreMorph
 scoreMorph := ScoreMorph new.! !

!ReversiController methodsFor: 'as yet unclassified' stamp: 'imy 4/16/2012 08:51'!
exit
	"Closes me."

	walkieTalkie disconnect.
	container delete.! !

!ReversiController methodsFor: 'as yet unclassified' stamp: 'imy 4/16/2012 07:09'!
initialize 
 container := Morph new 
              layoutPolicy: TableLayout new; 
              color: (Color red alpha: 0).
 currentPlayer:=0.
 self createScoreMorph.
moves:=4.
onePlayer:=false.
	walkieTalkie := WalkieTalkie new.
 ^self.! !

!ReversiController methodsFor: 'as yet unclassified' stamp: 'Me 4/16/2012 03:50'!
model
^model.! !

!ReversiController methodsFor: 'as yet unclassified' stamp: 'Me 4/16/2012 04:46'!
nextPlayer
	currentPlayer:=currentPlayer+1.
	(currentPlayer=2)
	ifTrue:
	[
		currentPlayer:=0.
	].
	turnShower setPlayer:currentPlayer.! !

!ReversiController methodsFor: 'as yet unclassified' stamp: 'Me 4/16/2012 05:42'!
open: bSize ai: foreverAlone
	boardSize:= bSize.
	onePlayer:=foreverAlone.
	model := ReversiModel new:boardSize.
	model controller: self.
	self createBoard.	
	self addGuiControls.
	container openInWorld.
	self validateBoard:onePlayer.! !

!ReversiController methodsFor: 'as yet unclassified' stamp: 'Me 4/16/2012 05:44'!
restart
 container delete.
 Smalltalk garbageCollect.
 ReversiController new open: boardSize ai:onePlayer.! !

!ReversiController methodsFor: 'as yet unclassified' stamp: 'Me 4/15/2012 19:03'!
score: change
 scoreMorph setScore: change second: moves.! !

!ReversiController methodsFor: 'as yet unclassified' stamp: 'imy 4/16/2012 08:35'!
startDoubleplayer

	walkieTalkie initializeAsListenerOnIP: #[127 0 0 1] port: 12345.
	[[walkieTalkie paired] whileFalse: [
		"waiting for incoming connection"
		"TODO: add break on outgoing connect"
		Processor yield.
		(Delay forMilliseconds: 1000) wait].
	"Start the game"
	self open: 6 ai: false.
	] fork.! !

!ReversiController methodsFor: 'as yet unclassified' stamp: 'Me 4/16/2012 04:46'!
validateBoard: useAI
|res c r tmp aCell|
	res:=-1.
	c:=-1.
	r:=-1.
	1 to:boardSize do:
	[ :row |
		1 to: boardSize do: 
		[ :col | 
			tmp := (model validateMoveAtRow: row c: col p:currentPlayer).
			(tmp>res)
				ifTrue: [res:=tmp. c:=col. r:=row.].
			(tmp>0)
			ifTrue:
			[
				(model at:row at:col) setState:2 c:col r:row.
			]
			ifFalse:
			[
				(model at:row at:col) setState: 1c:col r:row.
			].
		].
	].
	(currentPlayer=1 & useAI) 
		ifTrue:
		[
			self MakeStepRow: r col:c.
		].
	^res.! !

!ReversiController methodsFor: 'as yet unclassified' stamp: 'imy 4/16/2012 08:42'!
waitForNetworkMove
	| income |
[[income := walkieTalkie read] whileNil: [
	"Wait for the opponent move to come."
	Processor yield.
	(Delay forMilliseconds: 1000) wait].
	(income class = Point) ifTrue: [
		self MakeStepRow: income x col: income y]
] fork! !

LabelMorph subclass: #ScoreMorph
	instanceVariableNames: 'score'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ReversiGame'!

!ScoreMorph methodsFor: 'as yet unclassified' stamp: 'Me 4/15/2012 19:17'!
initialize 
 super initialize.
 self update: '0'.
 self extent: 40@40.
 score:=0.
^self.! !

!ScoreMorph methodsFor: 'as yet unclassified' stamp: 'Me 4/15/2012 19:16'!
setScore: s second: s2
 score:=score + s.
 self contents: 'White: ',(score asString) , ' Black: ' , ((s2-score) asString).
 self changed .
^self.! !

SimpleButtonMorph subclass: #BoardCell
	instanceVariableNames: 'controller rowNum colNum fMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ReversiGame'!

!BoardCell methodsFor: 'as yet unclassified' stamp: 'Me 4/16/2012 03:51'!
controller
^controller.! !

!BoardCell methodsFor: 'as yet unclassified' stamp: 'Me 4/16/2012 05:24'!
initialize 
 super initialize.
 self borderWidth: 1. 
 self on: #mouseDown send: #value to: (self onClickExecutionBlock). 
^self.! !

!BoardCell methodsFor: 'as yet unclassified' stamp: 'Me 4/15/2012 23:52'!
occupie: player
	(fMorph isNil )
	ifTrue:
	[
		fMorph:=FigureMorph new.
		fMorph setPlayer: player.  	
		self addMorph:  fMorph.
		controller score:(player ).
	]
	ifFalse:
	[
		fMorph setPlayer: player.  
		controller score:(player*2-1).
	].
	
	
! !

!BoardCell methodsFor: 'as yet unclassified' stamp: 'Me 4/15/2012 20:38'!
occupied
	^(fMorph isNil) not.
! !

!BoardCell methodsFor: 'as yet unclassified' stamp: 'Me 4/16/2012 04:45'!
occupiedBy: player
	^(fMorph getPlayer = player).
! !

!BoardCell methodsFor: 'as yet unclassified' stamp: 'Me 4/16/2012 05:27'!
onClickExecutionBlock
^[
	controller MakeStepRow: rowNum col:colNum.
 ]! !

!BoardCell methodsFor: 'as yet unclassified' stamp: 'Me 4/16/2012 05:30'!
setController: newController row: aRow col: aCol
 self layoutPolicy: RowLayout new.
 controller := newController.
 rowNum := aRow.
 colNum := aCol.
 self label: ''.
 self extent: 40@40.! !

!BoardCell methodsFor: 'as yet unclassified' stamp: 'Me 4/16/2012 05:32'!
setState: state c:col r:row
(state = 1)
ifTrue:
[
	color:= (Color r:0.2 g:0.2 b:0.2 alpha:0.3).
].
(state = 2)
ifTrue:
[
	color:=(Color r:0.7 g:0.2 b:0.2 alpha:0.4).
].
self changed.
! !

SimpleButtonMorph subclass: #FigureMorph
	instanceVariableNames: 'parentCell player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ReversiGame'!

!FigureMorph methodsFor: 'as yet unclassified' stamp: 'Me 4/16/2012 05:32'!
drawOn: aCanvas
|c|
	player=1
		ifTrue:[ c:= (Color r:1 g:1 b:1 alpha:0.9)]
		ifFalse:[ c:= (Color r:0.1 g:0.1 b:0.1 alpha: 0.9)].
	aCanvas fillOval: self bounds  color: c.! !

!FigureMorph methodsFor: 'as yet unclassified' stamp: 'Me 4/15/2012 16:43'!
getPlayer
	^player.
	! !

!FigureMorph methodsFor: 'as yet unclassified' stamp: 'Me 4/15/2012 17:46'!
initialize 
 super initialize.
 self label: ''.
 self borderWidth: 0. 
 self extent: 36@36.
	player:=0.
^self.! !

!FigureMorph methodsFor: 'as yet unclassified' stamp: 'Me 4/15/2012 17:53'!
setPlayer: playerNum
	player:=playerNum.
	self changed.
	! !
